public abstract static class EMCCVMenuElement extends EMCCVElement {  
  public String id;
  public String title = "unknown title";
  public boolean incognito = false;
  public boolean disabled = false;
  public int checked = 0; // 0 = not checked; 1 = active; -1 = inactive

  // shortcut for randomizing content
  public String randomize;

  public abstract void toggleState();
  public abstract void randomize();

  public boolean isDisabled() {
    return this.disabled || !checkParents(this.parent);
  }
}


public static class EMCCVThumb {
  
  public static final int W = 152;
  public static final int H = 150;
  public int x;
  public int y;
  public final String SRC;
  
  static ArrayList<EMCCVThumb> thumbs = new ArrayList<EMCCVThumb>();
  
  public EMCCVThumb(final String SRC) {
    this.SRC = SRC;
    
    if (logging && logActions) log.append(getTime() + "Thumbnail created: SRC = " + SRC + "\n");
  }
  
  public boolean mouseOver(int x, int y) {
    if (x >= this.x && x <= this.x + W && 
        y >= this.y && y <= this.y + H) {
      return true;
    } else {
      return false;
    }  
  }
}



public static class EMCCVButton {
  public final int X;
  public final int Y;
  public final int W;
  public final int H;
  public final String type;
  public final EMCCVMenuElement ELEMENT;

  // CHECKBOX, RADIOBUTTONS?
  public EMCCVButton(final int X, final int Y, final int W, final int H, EMCCVMenuElement ELEMENT) {
    this.X = X;
    this.Y = Y;
    this.W = W;
    this.H = H;
    this.type = "toggle";
    this.ELEMENT = ELEMENT;
  }

  // COG, CP, LINK
  public EMCCVButton(final int X, final int Y, final int W, final int H, String type, EMCCVMenuElement ELEMENT) {
    this.X = X;
    this.Y = Y;
    this.W = W;
    this.H = H;
    this.type = type;
    this.ELEMENT = ELEMENT;
  }
  
  public boolean isMouseOver(int x, int y) {
    if (x >= this.X && x <= this.X + this.W && y >= this.Y && y <= this.Y + this.H) {
      return true;
    }
    return false;
  }
}