public static class EMCCVStyle extends EMCCVMenuElement {
  public static int WIDTH = 280;

  public boolean selected = false;
  public String stylegroup = "default";
  public ArrayList<EMCCVFile> files = new ArrayList<EMCCVFile>();


  @Override
  public boolean isActive() {
    if (this.disabled || !this.selected) return false;
    if (this.checked == 0) {
      boolean bResult = true;
      
      EMCCVMenuElement xmlParent = this.getXMLParent();
      if (xmlParent != null) {
        if (logging && logInfo) log.append(getTime() + "[DRAW][IS ACTIVE][STYLE] id - " + this.id + "\n");
        if (logging && logInfo) log.append(getTime() + "[DRAW][IS ACTIVE][STYLE] xmlParent.id - " + xmlParent.id + "\n");
        bResult = xmlParent.isActive();
      }
  
      if (bResult && this.parent != null && !this.parent.equals("")) {      
        bResult = bResult && checkParents(this.parent);
      }
  
      bResult = bResult && !this.disabled && this.selected;

      if (bResult) {
        checked = 1;
      } else {
        checked = -1;
      }
    }
    return this.checked == 1;
  }

  @Override
    public void toggleState() {
    selected = !selected;
  }
  
  @Override
  public void randomize() {
    // do nothing;
  }
}