void drawColorPicker() {
  
  // Background
  fill(GUI_ACTIVE);
  rect(0, MENUSET_Y + MENUSET_H, ASPECTMENU_W, height - MENUSET_Y - MENUSET_H);
  
  // Title
  textAlign(LEFT, CENTER);
  fill(GUI_TEXT);
  text("COLOR PICKER: " + activeAspect.title, ASPECTMENU_X, ASPECTMENU_Y);
  text("0", GRADIENT_B_X + GRADIENT_W + PADDING, GRADIENT_Y);
  text("255", GRADIENT_B_X + GRADIENT_W + PADDING, GRADIENT_Y + GRADIENT_H);
  
  textAlign(CENTER, CENTER);
  text("HUE", GRADIENT_H_X, GRADIENT_Y + GRADIENT_H + PADDING, GRADIENT_W, MARGIN);
  text("SAT", GRADIENT_S_X, GRADIENT_Y + GRADIENT_H + PADDING, GRADIENT_W, MARGIN);
  text("BRI", GRADIENT_B_X, GRADIENT_Y + GRADIENT_H + PADDING, GRADIENT_W, MARGIN);
  textSize(26); 
  text("" + floor(hue(activeAspect.colour)), GRADIENT_H_X, GRADIENT_Y + GRADIENT_H + PADDING*2, GRADIENT_W, MARGIN*2);
  text("" + floor(saturation(activeAspect.colour)), GRADIENT_S_X, GRADIENT_Y + GRADIENT_H + PADDING*2, GRADIENT_W, MARGIN*2);
  text("" + floor(brightness(activeAspect.colour)), GRADIENT_B_X, GRADIENT_Y + GRADIENT_H + PADDING*2, GRADIENT_W, MARGIN*2);
  textSize(TEXTSIZE);
  
  // Active Colour
  fill(activeAspect.colour);
  rect(GRADIENT_H_X, ASPECTMENU_Y + 20, GRADIENT_W*3 + PADDING*2, GRADIENT_W-PADDING);
  
  // Original Colour
  if (!bTempColor) {
    tempColor = activeAspect.colour;
    bTempColor = true;
  }
  
  fill(tempColor);
  stroke(GUI_ACTIVE);
  rect(GRADIENT_H_X-1, ASPECTMENU_Y + 19, 20, 20);
  noStroke();
  
  // HUE
  fill(0, 0, brightness(activeAspect.colour));
  rect(GRADIENT_H_X, GRADIENT_Y, GRADIENT_W, GRADIENT_H);
  tint(0, 0, brightness(activeAspect.colour), saturation(activeAspect.colour));
  image(IMG_GRADIENT_HUE, GRADIENT_H_X, GRADIENT_Y, GRADIENT_W, GRADIENT_H);
  
  // SATURATION
  fill(0, 0, brightness(activeAspect.colour));
  rect(GRADIENT_S_X, GRADIENT_Y, GRADIENT_W, GRADIENT_H);
  tint(hue(activeAspect.colour), 255, brightness(activeAspect.colour));
  image(IMG_GRADIENT_SAT, GRADIENT_S_X, GRADIENT_Y, GRADIENT_W, GRADIENT_H);
  
  // BRIGHTNESS
  tint(hue(activeAspect.colour), saturation(activeAspect.colour), 255);
  image(IMG_GRADIENT_BRI, GRADIENT_B_X, GRADIENT_Y, GRADIENT_W, GRADIENT_H);
  
  // PALETTE
  int palX;
  int palY = SWATCH_Y;
  colorlist.clear();
  for (int i = 0; i < COLOURS_50BRI.size(); i++) {
    color c = color((int) COLOURS_50BRI.get(i));
    colorlist.add(c);
  }
  for (EMCCVFile file : fileLayers) {
    if (!colorlist.contains(file.getColour())) {
      
      colorlist.add(file.getColour());
    }
  }
  for (Object o : colorlist) {
    //if (colorlist.size() == 0 || hue(file.getColour()) > hue((color) colorlist.get(colorlist.size()-1))) {
    //  colorlist.add(file.getColour());
    //} else {
    //  for (int i = 0; i < colorlist.size(); i++) {
    //    if (hue(file.getColour()) > hue((color) colorlist.get(i))) {
    //      colorlist.add(i, file.getColour());
    //      break;
    //    }
    //  }
    //}
    
    fill((color) o);
    palX = SWATCH_X + MARGIN  * (colorlist.indexOf(o) % 10) + 1 * (colorlist.indexOf(o) % 10);
    palY = SWATCH_Y + MARGIN * (colorlist.indexOf(o) / 10) + 1 * (colorlist.indexOf(o) / 10);
    rect(palX, palY, MARGIN, MARGIN); 
  }
  
  
  // MARKERS
  if (saturation(activeAspect.colour) < 60 && brightness(activeAspect.colour) > 230) {
    stroke(0);
  } else {
    stroke(255);
  }
  line(GRADIENT_H_X -1,         GRADIENT_Y + hue(activeAspect.colour),
       GRADIENT_H_X+GRADIENT_W, GRADIENT_Y + hue(activeAspect.colour));
       
  line(GRADIENT_S_X -1,         GRADIENT_Y + saturation(activeAspect.colour),
       GRADIENT_S_X+GRADIENT_W, GRADIENT_Y + saturation(activeAspect.colour));
       
  line(GRADIENT_B_X -1,         GRADIENT_Y + brightness(activeAspect.colour),
       GRADIENT_B_X+GRADIENT_W, GRADIENT_Y + brightness(activeAspect.colour));
  
  noFill();
  noTint();
  noStroke();
}

void exitCP() {
  mode = PLAY;
  bTempColor = false;
  redrawAspectMenu = true;
  activeAspect = null;
}