void mouseMoved() {
  cursor(ARROW); // default

  if (mode != DASH) {

    // TOOLBAR
    if (mouseY > EMCCVTool.TOOLBAR_Y && mouseY < EMCCVTool.TOOLBAR_Y + EMCCVTool.TOOLBAR_H) {
      if (mode != SAVE && mode != RELOAD && mode != SAVE && mode != CAPTURE) {
        for (EMCCVTool tool : EMCCVTool.tools) {
          if (tool.mouseOver(mouseX, mouseY)) {
            cursor(HAND);
            break;
          }
        }
      }
    } else if (mode == CP && (mouseOverHue() || mouseOverSat() || mouseOverBri() || mouseOverModel() || mouseOverTempColor() || mouseOverSwatch())) {
      cursor(CROSS);
    } else if (TOOL_LOAD.active) {
      for (EMCCVThumb thumb : EMCCVThumb.thumbs) {
        if (thumb.mouseOver(mouseX, mouseY)) {
          cursor(HAND);
          break;
        }
      }
    } else if (mouseX >= ASPECTMENU_X && mouseX <= getAspectTitleX() || mouseY >= MENUSET_Y && mouseY <= MENUSET_Y + MENUSET_H) {
      for (EMCCVButton button : buttonList) {
        if (button.isMouseOver(mouseX, mouseY)) {
          cursor(HAND);
          break;
        }
      }
    } else if (activeModule.activeSet.scrollable && mouseX >= ASPECTMENU_W-32 && mouseX <= ASPECTMENU_W && mouseY >= IMG_Y && mouseY <= IMG_Y + 32*4) {
      cursor(HAND);
    }
  } else if (TOOL_LOG.mouseOver(mouseX, mouseY)) {
    cursor(HAND);    
  } else if (moduleids.size() > 0) {
    for (EMCCVButton button : buttonList) {
      if (button.isMouseOver(mouseX, mouseY)) {
        cursor(HAND);
        break;
      }
    }
  }
}

void mouseClicked() {

  if (mode != DASH) {

    if (mouseY >= EMCCVTool.Y && mouseY <= EMCCVTool.Y + EMCCVTool.ICON_SIZE) {
      if (mode != SAVE && mode != RELOAD && mode != SAVE && mode != CAPTURE) {
        reactToToolbarClick(); // TOOLBAR CLICK
      }
    } else if (mode == CP) {
      if (mouseY < IMG_Y) {
        exitCP();
        redraw();
      } else {
        processColorpickerClick();
      }
    } else if (mode == LOAD) {
      if (mouseY > IMG_Y && EMCCVThumb.thumbs.size() > 0) {
        processThumbnailClick();
      } else {
        mode = PLAY;
        redraw();
      }
    } else if (mode == PLAY) {
      if (activeModule.activeSet.scrollable && mouseX >= ASPECTMENU_W-32 && mouseX <= ASPECTMENU_W && mouseY >= IMG_Y && mouseY <= IMG_Y+128) {
        if (mouseY <= IMG_Y+32) {
          activeModule.activeSet.offset = 0;
        } else if (mouseY <= IMG_Y+64) {
          activeModule.activeSet.offset--;
          if (activeModule.activeSet.offset < 0) {
            activeModule.activeSet.offset = 0;
          }
        } else if (mouseY <= IMG_Y+96) {
          activeModule.activeSet.offset++;
        } else if (mouseY <= IMG_Y+128) {
          activeModule.activeSet.offset = activeModule.activeSet.getNumberOfPositions() - ((height - ASPECTMENU_Y) / ASPECTMENU_D);
        }
        redrawAspectMenu = true;
        redraw();

      } else if ((mouseX >= ASPECTMENU_X && mouseX <= COG_X+CONTROLSIZE) || mouseY >= MENUSET_Y && mouseY <= MENUSET_Y + MENUSET_H) {
        processButtonClick();
      }
    }
  } else if (TOOL_LOG.mouseOver(mouseX, mouseY)) {
    if (logging && logActions) log.append(getTime() + " LOG CLICK\n");
    reactToToolbarClick();
  } else if (moduleids.size() > 0) {
    for (EMCCVButton button : buttonList) {
      if (button.isMouseOver(mouseX, mouseY)) {
        EMCCVModule module = (EMCCVModule) button.ELEMENT;
        initXML(module.id);
        mode = PLAY;
        TOOL_DASH.active = false;
        redrawSetMenu    = true;
        redrawAspectMenu = true;
        redrawToolbar    = true;
        redrawModel      = true;
        redraw();
      }
    }
  }

  // RESIZE WHEN NEEDED
  if (currentWidth != width || currentHeight != height) {
    redrawSetMenu = true;
    redrawAspectMenu = true;
    redrawModel = true;
    currentWidth = width;
    currentHeight = height;
    redraw();
  }
}

void keyPressed() {
  String sKey = String.valueOf(key);

  if (sKey.equals("0") ||
    sKey.equals("1") ||
    sKey.equals("2") ||
    sKey.equals("3") ||
    sKey.equals("4") ||
    sKey.equals("5") ||
    sKey.equals("6") ||
    sKey.equals("7") ||
    sKey.equals("8") ||
    sKey.equals("9")) {

    int index = Integer.valueOf(sKey);

    if (index < setList.size()) {
      for (EMCCVSet set : setList) {
        set.selected = false;
      }

      setList.get(index).selected = true;

      redrawSetMenu = true;
      exitCP();

      redraw();
    }
  } else if (mode != CP && randomKeys.containsKey(sKey)) {

    if (!(randomKeys.get(sKey) instanceof EMCCVAspect) || randomKeys.get(sKey).isActive()) {
      randomKeys.get(sKey).randomize();
      redrawAspectMenu = true;
      redrawModel = true;
      redraw();
    }
  }
}

public void processButtonClick() {
  for (EMCCVButton button : buttonList) {

    if (mouseX >= button.X && mouseX <= button.X + button.W && mouseY >= button.Y && mouseY <= button.Y + button.H) {

      if (button.ELEMENT instanceof EMCCVSet) {
        if (logging && logActions) log.append(getTime() + " CLICKED: " + button.ELEMENT.title + " (SET)\n");

        for (EMCCVSet set : setList) {
          set.selected = false;
        }
        activeModule.activeSet = (EMCCVSet) button.ELEMENT;
        button.ELEMENT.toggleState();

        if (!TOOL_GLOBALMODE.active) { 
          TOOL_COLORLINK.active = activeModule.activeSet.colorlink;
          TOOL_COLORCHAIN.active = activeModule.activeSet.colorchain;
          TOOL_COLLAPSE.active = activeModule.activeSet.collapse;
          redrawToolbar    = true;
        }
        redrawSetMenu    = true;
        redrawAspectMenu = true;
        redrawModel      = true;
        TOOL_LOAD.active = false;
        exitCP();
        redraw();
      } else if (mode != CP && button.ELEMENT instanceof EMCCVAspect) {

        EMCCVAspect aspect = (EMCCVAspect) button.ELEMENT;
        if (logging && logInfo) log.append(getTime() + "[CHECKPARENTS] of " + aspect.title + ": " + checkParents(aspect.parent));

        if (button.type.equals("cp")) {
          if (logging && logActions) log.append(getTime() + " CLICKED: " + button.ELEMENT.title + " (ASPECT CP)\n");
          activeAspect = (EMCCVAspect) button.ELEMENT;
          activeAspect.visible = true;
          mode = CP;
          redraw();
        } else if (button.type.equals("link")) {
          if (logging && logActions) log.append(getTime() + " CLICKED: " + button.ELEMENT.title + " (ASPECT COLORCHAIN)\n");
          aspect.colorchain = !aspect.colorchain;
          redrawAspectMenu = true;
          redraw();
        } else if (button.type.equals("cog")) {
          if (logging && logActions) log.append(getTime() + " CLICKED: " + button.ELEMENT.title + " (ASPECT COG)\n");
          if (aspect == activeModule.activeSet.activeAspect) {
            activeModule.activeSet.activeAspect = null;
            redrawAspectMenu = true;
            redraw();
          } else {
            activeModule.activeSet.activeAspect = aspect;
            aspect.visible = true;
            redrawAspectMenu = true;
            redraw();
          }
        } else if (!aspect.alwayson && !aspect.isDisabled()) {
          if (logging && logActions) log.append(getTime() + " CLICKED: " + button.ELEMENT.title + " (ASPECT VISIBILITY)\n");
          button.ELEMENT.toggleState();
          redrawAspectMenu = true;
          redrawModel = true;
          redraw();
        }
      } else if (mode != CP && button.ELEMENT instanceof EMCCVStyle && !button.ELEMENT.isDisabled()) {
        if (logging && logActions) log.append(getTime() + " CLICKED: " + button.ELEMENT.title + " (STYLE)\n");

        if (button.ELEMENT.getXMLParent() != null) {          
          EMCCVStyle style   = (EMCCVStyle) button.ELEMENT;
          EMCCVAspect aspect = (EMCCVAspect) button.ELEMENT.getXMLParent();

          if (logging && logInfo) log.append(getTime() + "[CHECKPARENTS] " + aspect.title + ": " + checkParents(aspect.xmlParent));

          for (Map.Entry<String, EMCCVStylegroup> entry : aspect.stylegroups.entrySet()) {
            if (entry.getValue().title.equals(style.stylegroup)) {
              entry.getValue().resetStyles();
              break;
            }
          }
          aspect.visible = true;
        }

        button.ELEMENT.toggleState();
        redrawAspectMenu = true;
        redrawModel = true;
        redraw();
      }
    }
  }
}

void reactToToolbarClick() {
  for (EMCCVTool tool : EMCCVTool.tools) {
    boolean processed = false;
    if (tool.mouseOver(mouseX, mouseY)) {
      tool.active = !tool.active;

      // Set-Tools
      if (tool == TOOL_LOG) {
        if (logging && logActions) log.append(getTime() + " LOG CLICK\n");
        logging = !logging;
      } else if (tool == TOOL_COLORCHAIN) {
        activeModule.activeSet.colorchain = tool.active;
      } else if (tool == TOOL_COLORLINK) {
        activeModule.activeSet.colorlink = tool.active;
      } else if (tool == TOOL_COLLAPSE) {
        activeModule.activeSet.collapse = tool.active;
      } else if (tool == TOOL_GLOBALMODE) {
        TOOL_COLORLINK.active  = activeModule.activeSet.colorlink;
        TOOL_COLORCHAIN.active = activeModule.activeSet.colorchain;
        TOOL_COLLAPSE.active   = activeModule.activeSet.collapse;
      } else if (tool == TOOL_CAPTURE) {
        if (logging && logActions) log.append(getTime() + " IMAGE CAPTURE CLICK\n");
        mode = CAPTURE;
        processCaptureClick();
      } else if (tool == TOOL_SAVE) {
        if (logging && logActions) log.append(getTime() + " SAVE ENTITY CLICK\n");
        mode = SAVE;
        processSaveClick();
      } else if (tool == TOOL_LOAD) {
        if (logging && logActions) log.append(getTime() + " LOAD ENTITY CLICK\n");
        mode = LOAD;
        processLoadClick();
      } else if (tool == TOOL_RANDOMIZE) {
        if (logging && logActions) log.append(getTime() + " RANDOMIZE CLICK\n");
        mode = PLAY;
        TOOL_RANDOMIZE.active = false;
        if (TOOL_GLOBALMODE.active) {
          for (EMCCVSet set : setList) {
            set.randomize();
          }
        } else {
          activeModule.activeSet.randomize();
        }
      } else if (tool == TOOL_RANDOMIZECOLOR) {
        if (logging && logActions) log.append(getTime() + " RANDOMIZE COLOR CLICK\n");
        mode = PLAY;
        TOOL_RANDOMIZECOLOR.active = false;
        processRandomizeColorClick();
        refreshModel = true;
      } else if (tool == TOOL_COLORSHIFT) {
        if (logging && logActions) log.append(getTime() + " COLOR SHIFT CLICK\n");
        mode = PLAY;
        TOOL_COLORSHIFT.active = false;
        processColorShiftClick();
        refreshModel = true;
        redrawAspectMenu = true;
      } else if (tool == TOOL_RELOAD) {
        if (logging && logActions) log.append(getTime() + " RELOAD CLICK\n");
        mode = RELOAD;
        processReloadClick();
      } else if (tool == TOOL_DASH) {
        if (logging && logActions) log.append(getTime() + " DASH CLICK\n");
        processDashClick();
      }

      redrawToolbar = true;
      processed = true;
      redraw();
    }
    if (processed) break;
  }
}

void processRandomizeColorClick() {
  if (!TOOL_COLORLINK.active) {
    //run through every aspect in every set and apply a new random color
    if (TOOL_GLOBALMODE.active) {
      if (logging && logInfo) log.append(getTime() + "[RANDOMIZE COLORS] entered in GLOBAL MODE, no COLORLINK\n");
      for (EMCCVSet set : setList) {
        for (String aspectID : set.aspects) {
          EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectID);
          if (aspect != null && aspect.randomizecolor) {
            aspect.colour = (color((int)random(255),(int)random(255),(int)random(255)));
          }
        }
      }
    } else {
      if (logging && logInfo) log.append(getTime() + "[RANDOMIZE COLORS] entered in TAB MODE, no COLORLINK\n");
      for (String aspectID : activeModule.activeSet.aspects) {
        EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectID);
        if (aspect != null && aspect.randomizecolor) {
          aspect.colour = (color((int)random(255),(int)random(255),(int)random(255)));
        }
      }
    }
    
  } else {
    ArrayList oldcolors = new ArrayList(); // current colors
    ArrayList newcolors = new ArrayList(); // new random colors
    
    // find all colours currently in use and match it with a random one
    for (EMCCVFile file : fileLayers) {
      if (!oldcolors.contains(file.getColour())) {
        oldcolors.add(file.getColour()); // current color
        newcolors.add(color((int)random(255),(int)random(255),(int)random(255))); // corresponding random color
      }
    }
    
    //run through every aspect in every set and apply the matching random color
    if (TOOL_GLOBALMODE.active) {
      if (logging && logInfo) log.append(getTime() + "[RANDOMIZE COLORS] entered in GLOBAL MODE with COLORLINK\n");
      for (EMCCVSet set : setList) {
        for (String aspectID : set.aspects) {
          EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectID);
          if (aspect != null && aspect.randomizecolor) {
            int i = oldcolors.indexOf(aspect.colour);
            aspect.colour = (int) newcolors.get(i);
          }
        }
      }
    } else {
      if (logging && logInfo) log.append(getTime() + "[RANDOMIZE COLORS] entered in TAB MODE with COLORLINK\n");
      for (String aspectID : activeModule.activeSet.aspects) {
        EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectID);
        if (aspect != null && aspect.randomizecolor) {
          int i = oldcolors.indexOf(aspect.colour);
          aspect.colour = (int) newcolors.get(i);
        }
      }
    }
  }
}
void processColorShiftClick() {
  ArrayList oldcolors = new ArrayList(); // current colors
  
  // find all colours currently in use and match it with a random one
  for (EMCCVFile file : fileLayers) {
    if (!oldcolors.contains(file.getColour())) {
      oldcolors.add(file.getColour()); // current color
    }
  }
  
  //run through every aspect in every set and shift the color
  if (TOOL_GLOBALMODE.active) {
    for (EMCCVSet set : setList) {
      for (String aspectID : set.aspects) {
        EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectID);
        if (aspect != null && aspect.randomizecolor) {
          int i = oldcolors.indexOf(aspect.colour);
          aspect.colour = (int) oldcolors.get((i+1) % oldcolors.size());
        }
      }
    }
  } else {
    for (String aspectID : activeModule.activeSet.aspects) {
      EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectID);
      if (aspect != null && aspect.randomizecolor) {
        int i = oldcolors.indexOf(aspect.colour);
        aspect.colour = (int) oldcolors.get((i+1) % oldcolors.size());
      }
    }
  }
}
void processCaptureClick() {
  pgExport.save(sketchPath(DIR_IMAGES + getDateTime()  + ".png"));
}

void processLoadClick() {
  if (TOOL_LOAD.active) {
    EMCCVThumb.thumbs.clear();

    File dir = new File(sketchPath(DIR_ENTITIES));

    File[] files = dir.listFiles();

    if (files != null) {
      if (logging && logInfo) log.append(getTime() + "[LOAD] Number of files found: " + files.length + "\n");
      for (File file : files) {
        String filename = file.getName();
        if (filename.contains(".png")) {
          EMCCVThumb thumb = new EMCCVThumb(filename.substring(0, filename.toString().lastIndexOf(".")));
          EMCCVThumb.thumbs.add(thumb);
        }
      }
    }
  } else {
    redrawAspectMenu = true;
    redrawModel = true;
  }
}

void processReloadClick() {
  redrawSetMenu    = true;

  if (mode == DASH) {
    drawModuleMenu();
  } else {
    initXML(activeModule.id);
  }
  redraw();
}

void processDashClick() {
  if (mode == DASH) {
    exit();
  } else {
    port_W = 0;
    port_H = 0;
    surface.setSize(800, 400);
    setList.clear();
    elements.clear();
    TOOL_LOAD.active = false;
    TOOL_DASH.active = true;
    redrawSetMenu    = true;
    redrawToolbar    = true;
    mode = DASH;
    redraw();
  }
}

void processSaveClick() {
  String filename = getDateTime();
  PImage thumb = pg.copy();
  thumb.resize(0, 150);
  thumb.save(sketchPath(DIR_ENTITIES + filename  + ".png"));

  PrintWriter output = createWriter(sketchPath(DIR_ENTITIES + filename + ".txt"));

  for (EMCCVSet set : setList) {
    for (String aspectid : set.aspects) {
      StringBuilder sb = new StringBuilder();
      EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectid);

      if (aspect.visible || aspect.alwayson) {
        sb.append(aspect.id).append(";").append(aspect.colour).append(";");

        for (Map.Entry<String, EMCCVStylegroup> groupentry : aspect.stylegroups.entrySet()) {
          for (Map.Entry<String, EMCCVStyle> styleentry : groupentry.getValue().styles.entrySet()) {
            if (styleentry.getValue().selected) {
              sb.append(styleentry.getValue().id).append(";");
              break;
            }
          }
        }
        output.println(sb.toString());
      }
    }
  }
  output.flush(); // Writes the remaining data to the file
  output.close(); // Finishes the file
}

void processColorpickerClick() {

  ArrayList<EMCCVAspect> list = new ArrayList<EMCCVAspect>();

  boolean mouseOverColor = mouseOverHue() || mouseOverSat() || mouseOverBri() || mouseOverModel() || mouseOverTempColor() || mouseOverSwatch();

  // find all aspects with the same colour or part of the color chain
  if (mouseOverColor) {
    if (TOOL_COLORLINK.active || TOOL_COLORCHAIN.active) {

      if (TOOL_GLOBALMODE.active) {
        for (EMCCVSet set : setList) {
          for (String aspectid : set.aspects) {
            EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectid);
            if (TOOL_COLORLINK.active && aspect.colour == activeAspect.colour) {
              list.add(aspect);
            } else if (TOOL_COLORCHAIN.active && activeAspect.colorchain && aspect.colorchain) {
              list.add(aspect);
            }
          }
        }
      } else {
        for (String aspectid : activeModule.activeSet.aspects) {
          EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectid);
          if (TOOL_COLORLINK.active && aspect.colour == activeAspect.colour) {
            list.add(aspect);
          } else if (TOOL_COLORCHAIN.active && activeAspect.colorchain && aspect.colorchain) {
            list.add(aspect);
          }
        }
      }
    }
  }

  if (mouseOverHue() || mouseOverSat() || mouseOverBri()) {

    float hue = hue(activeAspect.colour);
    float sat = saturation(activeAspect.colour);
    float bri = brightness(activeAspect.colour);
    float value = mouseY - GRADIENT_Y;

    // HUE
    if (mouseOverHue()) {
      activeAspect.colour = color(value, sat, bri);
    }
    // SATURATION
    else if (mouseOverSat()) {
      activeAspect.colour = color(hue, value, bri);
    }
    // BRIGHTNESS
    else if (mouseOverBri()) {
      activeAspect.colour = color(hue, sat, value);
    }
  } else if (mouseOverModel() || mouseOverTempColor() || mouseOverSwatch()) {
    activeAspect.colour = get(mouseX, mouseY);
  }

  if ((TOOL_COLORLINK.active || TOOL_COLORCHAIN.active) && mouseOverColor) {
    for (EMCCVAspect aspect : list) {
      aspect.colour = activeAspect.colour;
    }
  }

  redrawModel = true;
  redraw();
}

void processThumbnailClick() {
  for (EMCCVThumb thumb : EMCCVThumb.thumbs) {
    if (thumb.mouseOver(mouseX, mouseY)) {
      // A THUMBNAIL HAS BEEN CLICKED
      cursor(WAIT);
      if (logging && logActions) log.append(getTime() + "THUMB CLICK: " + thumb.SRC + "\n");

      // loading the txt file
      String[] stringlist = loadStrings(sketchPath(DIR_ENTITIES + thumb.SRC + ".txt"));

      if (stringlist.length > 0) {

        // turn all aspects off
        for (EMCCVSet set : setList) {
          for (String aspectid : set.aspects) {
            EMCCVAspect aspect = (EMCCVAspect) elements.get(aspectid);
            aspect.visible = false;
          }
        }

        // go through all lines in txt and apply them
        for (String s : stringlist) {
          String[] tokens = split(s, ";");
          EMCCVAspect aspect = (EMCCVAspect) elements.get(tokens[0]);
          if (aspect != null) {
            aspect.visible = true;
            try {
              if (tokens[1].charAt(0) == '#') {
                aspect.colour = unhex("FF" + tokens[1].substring(1));
              } else {
                aspect.colour = color(Integer.parseInt(tokens[1]));
              }
            } 
            catch (Exception e) {
              if (logging && logInfo) log.append(getTime() + "[LOADING ENTITY] ASPECT: " + aspect.id + "; COLOR INVALID\n");
            }
            for (int i = 2; i < tokens.length-1; i++) {
              EMCCVStyle style = (EMCCVStyle) elements.get(tokens[i]);
              if (style != null) {
                if (logging && logInfo) log.append(getTime() + "[LOADING ENTITY] ASPECT: " + aspect.id + "; STYLE: " + style.id + " (group: " + style.stylegroup + ")\n");
                EMCCVStylegroup group = aspect.stylegroups.get(style.stylegroup);
                group.resetStyles();
                style.selected = true;
              } else {
                log.append(getTime() + "[LOADING ENTITY] STYLE NOT FOUND: " + tokens[i] + "\n");
              }
            }
          } else {
            log.append(getTime() + "[LOADING ENTITY] ASPECT NOT FOUND: " + tokens[0] + "\n");
          }
        }
      }
    }
    // FINISHED LOADING ENTITY
    redrawAspectMenu = true;
    redrawModel      = true;
    refreshModel     = true;
    TOOL_LOAD.active = false;
    mode = PLAY;
    redraw();
  }
}


boolean mouseOverHue() {
  if (mouseX >= GRADIENT_H_X && mouseX <= GRADIENT_H_X+GRADIENT_W &&
    mouseY >= GRADIENT_Y && mouseY <= GRADIENT_Y + GRADIENT_H) {
    return true;
  } else {
    return false;
  }
}

boolean mouseOverSat() {
  if (mouseX >= GRADIENT_S_X && mouseX <= GRADIENT_S_X+GRADIENT_W &&
    mouseY >= GRADIENT_Y && mouseY <= GRADIENT_Y + GRADIENT_H) {
    return true;
  } else {
    return false;
  }
}

boolean mouseOverBri() {
  if (mouseX >= GRADIENT_B_X && mouseX <= GRADIENT_B_X+GRADIENT_W &&
    mouseY >= GRADIENT_Y && mouseY <= GRADIENT_Y + GRADIENT_H) {
    return true;
  } else {
    return false;
  }
}

boolean mouseOverModel() {
  if (mouseX >= IMG_X && mouseX <= IMG_X+view_W && 
    mouseY >= IMG_Y && mouseY <= IMG_Y+view_H) {
    return true;
  } else {
    return false;
  }
}

boolean mouseOverTempColor() {
  if (mouseX >= GRADIENT_H_X && mouseX <= GRADIENT_H_X + 20 && 
    mouseY >= ASPECTMENU_Y + 19 && mouseY <= ASPECTMENU_Y + 39) {
    return true;
  } else {
    return false;
  }
}

boolean mouseOverSwatch() {
  int columns = colorlist.size();
  if (columns > 10) {
    columns = 10;
  }
  if (mouseX >= SWATCH_X && mouseX <= SWATCH_X + (MARGIN+1)*(columns) && 
    mouseY >= SWATCH_Y && mouseY <= SWATCH_Y + (MARGIN+1)*(colorlist.size() / 10) + MARGIN) {
    return true;
  } else {
    return false;
  }
}